#include <iostream>
#include <string>
using namespace std;

//Connect to the Library of functions
#import "..\MazeFunctionLibrary\bin\Release\MazeFunctionLibrary.tlb" raw_interfaces_only
using namespace MazeFunctionLibrary;

bool MazeRecursion(long curRow, long curCol);
void waitFunction();

bool found = false;
long * result = new long;
long * result2 = new long;
long * result3 = new long;

//Create the object for the rmgLibrary functions
HRESULT hr = CoInitialize(NULL);
rmgLibraryPtr rmgPtr(__uuidof(ManagedClass));

int main()
{
	string temp;
	

	do
	{
		cout << "We will start when you type go." << endl;
		cin >> temp;
	}
	while(temp != "go");

	//Start the Connection
	rmgPtr->StartConnection();

	
	//Get the current row and column needed to start the recursion
	rmgPtr->GetCurRow(result);
	rmgPtr->GetCurCol(result2);

	//Call the Recursive function
	if(MazeRecursion(*result, *result2) == true)
	{
		cout << "FOUND THE END" << endl;
	}
	else
	{
		cout << "WHAT!!!!!" << endl;
	}
	cout << "Press a button and press enter to end" << endl;
	cin >> temp;

	//Close the connections between the client and server
	rmgPtr->EndConnections();
	

	return 0;
}

//*************************************MazeRecursion****************************
// This function will use recursion in order to ry and reach the end of the
// maze. It will move through a set order, it will first move down then left,
// right, and then up. It will check and see if there is a wall in the direcion
// before moving the cursor. If the square is a wall then it will not move. The
// function will call MazeRecursion after each move in order to check the
// directions for the square that has been moved to. The function will return
// true if the endinf was found or false if it was not.
//*******************************************************************************
bool MazeRecursion(long curRow, long curCol)
{
	if(found == true)
	{
		return true;
	}
	else
	{
		rmgPtr->CheckEnd(result);
		if(*result == 1)	//Found Finish Line
		{
			found = true;
			return true;
		}
	}
	//Check down
	//1s = been path
	//2s = open path
	rmgPtr->CheckPathDown(result);
	if(*result == 2)	//Path
	{
		rmgPtr->MoveDown();
		//Save new current spot
		rmgPtr->GetCurRow(result2);
		rmgPtr->GetCurCol(result3);
		/*temp = curXLoc;
		temp2 = curYLoc;
		mazeRecursion(curXLoc, curYLoc);*/
		waitFunction();
		MazeRecursion(*result2,*result3);
	}
	//Then return to old position
	rmgPtr->MoveSetLocation(curRow,curCol);
	rmgPtr->CheckPathLeft(result);
	if(*result == 2)
	{
		rmgPtr->MoveLeft();
		rmgPtr->GetCurRow(result2);
		rmgPtr->GetCurCol(result3);
		waitFunction();
		MazeRecursion(*result2,*result3);
	}
	rmgPtr->MoveSetLocation(curRow,curCol);
	rmgPtr->CheckPathRight(result);
	if(*result == 2)
	{
		rmgPtr->MoveRight();
		rmgPtr->GetCurRow(result2);
		rmgPtr->GetCurCol(result3);
		waitFunction();
		MazeRecursion(*result2,*result3);
	}
	rmgPtr->MoveSetLocation(curRow,curCol);
	rmgPtr->CheckPathUp(result);
	if(*result == 2)
	{
		rmgPtr->MoveUp();
		rmgPtr->GetCurRow(result2);
		rmgPtr->GetCurCol(result3);
		waitFunction();
		MazeRecursion(*result2,*result3);
	}
	if(found == true)
	{
		return true;
	}

	//rmgPtr->CheckPathDown(result);
	//if(*result == 1)	//Path
	//{
	//	rmgPtr->MoveDown();
	//	MazeRecursion();
	//}
	//rmgPtr->CheckPathLeft(result);
	//if(*result == 1)
	//{
	//	rmgPtr->MoveLeft();
	//	MazeRecursion();
	//}
	//rmgPtr->CheckPathRight(result);
	//if(*result == 1)
	//{
	//	rmgPtr->MoveRight();
	//	MazeRecursion();
	//}
	//rmgPtr->CheckPathUp(result);
	//if(*result == 1)
	//{
	//	rmgPtr->MoveUp();
	//	MazeRecursion();
	//}
	
	
}

//*********************************WaitFunction**************************
// This function just runs a while loop that counts to a set number
// and is used to slow the recursive program down.
//***********************************************************************
void waitFunction()
{
	int i = 0;
	while(i < 10500000)
	{
		i++;
	}
}